<?php
/*---------------------------------------------------+
| LightNEasy Content Management System
| Copyright 2007 - 2011 Fernando Baptista
| http://www.lightneasy.org
+----------------------------------------------------+
| Addon Swipe Gallery
| Admin Module
| Version 1.0
| Copyright 2014 TIOUK
|
| Contains the work of Fernando Baptista, Stu Nichols (http://www.stunicholls.com) and Others.
|
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
|
| Swipe Galleries
|
+----------------------------------------------------*/
global $swipegallerymessage, $myserver, $prefix, $sqldbdb, $MySQL, $set;
if ($_SERVER['SERVER_NAME']!=$myserver)
	die ('Access Denied!');
if(file_exists("addons/swipegallery/lang/lang_".$set['language'].".php"))
	require_once "addons/swipegallery/lang/lang_".$set['language'].".php";
else
	require_once "addons/swipegallery/lang/lang_en_US.php";
require_once "addons/swipegallery/common.php";
// Check if table exists in the database
$query="";
if($MySQL==0) {
	if(!$aa=sqlite_fetch_column_types($prefix."sgimages", $sqldbdb))
		$query = "CREATE TABLE ".$prefix."sgimages ( id INTEGER NOT NULL PRIMARY KEY, file VARCHAR(20) NOT NULL, name VARCHAR(50) NOT NULL)";
} else
		$query = "CREATE TABLE IF NOT EXISTS ".$prefix."sgimages ( id INTEGER NOT NULL auto_increment, file VARCHAR(20) NOT NULL, name VARCHAR(50) NOT NULL, PRIMARY KEY (id))";

// Adding Menu Heading if not added to language file.
$done=0;
if(file_exists("addons/lang_".$set['language'].".php")) {
	$lines = file("addons/lang_".$set['language'].".php");
	foreach ($lines as $line){
		if (strpos($line, "swipe")){ 
			$done=1;
		}
	}
	if ($done==0) {
		array_pop($lines);
		$file = join('',$lines);
		$fileopen = fopen("addons/lang_".$set['language'].".php","w+");
		foreach ($lines as $line){
			fwrite($fileopen, "$line");
		}
		fwrite($fileopen, "\$swipegallery=\"SwipeGal\";\n");
		fwrite($fileopen, "?>");
		fclose($fileopen);
		$message="Added SwipeGal Menu Heading";
	}
}
$done=0;
if(file_exists("addons/lang_en_US.php")) {
	$lines = file("addons/lang_en_US.php");
	foreach ($lines as $line){
		if (strpos($line, "swipe")){ 
			$done=1;
		}
	}
	if ($done==0) {
		array_pop($lines);
		$file = join('',$lines);
		$fileopen = fopen("addons/lang_en_US.php","w+");
		foreach ($lines as $line){
			fwrite($fileopen, "$line");
		}
		fwrite($fileopen, "\$swipegallery=\"SwipeGal\";\n");
		fwrite($fileopen, "?>");
		fclose($fileopen);
		$message="Added SwipeGal Menu Heading";
	}
}
// end of menu heading

if($query!="")
	@dbquery($query);

if($_POST['submit']=="Delete Swipe Gallery") {
	$folder="swipegalleries/".$_POST['name'];
	$filez=filelist('/./', $folder);
	foreach($filez as $fil)
		$out.=deleteimage($folder."/".$fil,$fil);
	if(@rmdir($folder))
		$message=$swipegallerymessage[1];
	else
		$message=$swipegallerymessage[2];
	unset($_GET['do']);
}

if($_POST['submit']=="Create Swipe Gallery") {
	if(!is_dir("swipegalleries/".$_POST['galeryname'])) {
		mkdir("swipegalleries/".$_POST['galeryname'], 0777)
			or die ($swipegallerymessage[63]);
		$message=$swipegallerymessage[64];
	} else $message=$swipegallerymessage[65];
	unset($_GET['do']);
}

if($_POST['submit']=="Upload Image") {
	$message="";
	if($_FILES['uploadedfile']['name'] == ""){
		$message=$swipegallerymessage[120];
	} elseif($_FILES['uploadedfile']['error'] == 1) {
			$message=$swipegallerymessage[126];
	} elseif($_FILES['uploadedfile']['error'] == 2) {
			$message=$swipegallerymessage[122];
	} elseif ($_POST['gal']=="") {
		$message=$swipegallerymessage[121];
	}
	$target_path = "swipegalleries/".$_POST['gal']."/";
	$target_path = $target_path.basename( $_FILES['uploadedfile']['name']);
	if($message=="") {
		if(file_exists($target_path)) unlink($target_path);
		$imagename=encode(sanitize($_POST['imagename']));
		if(move_uploaded_file($_FILES['uploadedfile']['tmp_name'], $target_path)) {
			@chmod($target_path, 0644);
			dbquery("INSERT INTO ".$prefix."sgimages ( id, file, name ) VALUES (null, \"".basename($_FILES['uploadedfile']['name'])."\", \"$imagename\" )");
			$message=$swipegallerymessage[124].basename( $_FILES['uploadedfile']['name']).$swipegallerymessage[125];
		} else $message=$swipegallerymessage[123];
	}
	unset($_GET['do']);
}

if($_POST['submit']=="Submit Settings") {
	$message="";
	if(!is_intval($_POST['maxfilesize']) || !is_intval($_POST['thumbnailwidth']) || !is_intval($_POST['swipeheight'])) {
		$message = $swipegallerymessage[98];
	} elseif(!$fp=fopen("addons/swipegallery/settings.php","w")) {
		$message = $swipegallerymessage[55];
	} else {
	fwrite($fp,"<?php\n\$maxfilesize=".$_POST['maxfilesize'].";\n\$thumbnailwidth=".$_POST['thumbnailwidth'].";\n\$swipeHeight=".$_POST['swipeheight'].";\n?>\n");
	fclose($fp);
	$message=$swipegallerymessage[150];
	}
}

function sgimages() {
	global $swipegallerymessage, $max_upload_image_size, $prefix, $message;
	$out.="<h2>$swipegallerymessage[7]</h2>\n<hr />\n<div align=\"center\">\n";
//	if ($message="") { 
		$out.="<h2 class=\"LNE_message\">".$message."</h2>\n";
		$message="";
//	} else {
//		$out.="<h2 class=\"LNE_message\">No Message!</h2>\n";
//	}
	if($_GET['do']=="swipegallery" && $_GET['action']=="delete" && $_GET['name']!="") {
		$out.=deleteimage($_GET['name']);
	}
	if($_GET['do']=="swipegallery" && $_GET['action']=="deletegal" && $_GET['name']!="") {
		$swipegalleryname=$_GET['name'];
		$out.="<h4 style=\"color: red;\">".$swipegallerymessage[3]."$swipegalleryname?</h4>\n";
		$out.="<p>$swipegallerymessage[4]</p>\n";
		$out.="<form method=\"post\" action=\"\">\n";
		$out.="<input type=\"hidden\" name=\"name\" value=\"$swipegalleryname\" />\n";
		$out.="<input type=\"hidden\" name=\"submit\" value=\"Delete Swipe Gallery\" />\n";
		$out.="<input type=\"submit\" name=\"aaa\" value=\"".$swipegallerymessage[5]."\" />\n";
		$out.="</form>\n";
	}
	$out.="<h3>$swipegallerymessage[8]</h3>\n";
	if($maxfilesize=="")
		$maxfilesize=200000;
	if($thumbnailwidth=="")
		$thumbnailwidth=100;
	if($swipeHeight=="")
		$swipeHeight=400;
	if(file_exists("./addons/swipegallery/settings.php"))
		require_once "./addons/swipegallery/settings.php";
	$out.="<form method=\"post\" action=\"\">\n";
	$out.="<table><tr><td>$swipegallerymessage[9]&nbsp;</td><td><input type=\"text\" name=\"maxfilesize\" value=\"$maxfilesize\" /></td></tr>\n";
	$out.="<tr><td>$swipegallerymessage[10]&nbsp;</td><td><input type=\"text\" name=\"thumbnailwidth\" value=\"$thumbnailwidth\" /></td></tr>\n";
	$out.="<tr><td>$swipegallerymessage[12]&nbsp;</td><td><input type=\"text\" name=\"swipeheight\" value=\"$swipeHeight\" /></td></tr>\n";
	$out.="<tr><td><input type=\"hidden\" name=\"submit\" value=\"Submit Settings\" /></td><td><input type=\"submit\" name=\"aaa\" value=\"$swipegallerymessage[11]\" /></td></tr>\n";
	$out.="</table>\n</form>\n<hr />\n";
	
	$out.="<form enctype=\"multipart/form-data\" method=\"post\" action=\"\">\n<fieldset style=\"border: 0;\">\n";
	$out.="<h3>$swipegallerymessage[58]</h3>\n";
	$out.="<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"$maxfilesize\" />\n";
	$out.="<table>\n";
	$out.="<tr><td>$swipegallerymessage[60]</td><td><input type=\"text\" name=\"imagename\" value=\"\" style=\"width: 100%\" /></td></tr>\n";
	$out.="<tr><td>".$swipegallerymessage[59].":</td><td><input name=\"uploadedfile\" type=\"file\" />\n</td></tr>\n";
	$out.="<tr><td>".$swipegallerymessage[61].":</td><td>";
	$out.="<select name=\"gal\">\n";
	$folder="./swipegalleries";
	$files=filelist('/./',$folder,1);
	foreach($files as $file) {
		if($file != ".." && $file != "." && $file != "thumbs") {
		    $out.='<option value="'.$file."\">".$file."&nbsp;</option>\n";
		}
	}
	$out.="</select>\n</td></tr>\n";
	$out.="<tr><td></td><td>";
	$out.="<input type=\"hidden\" name=\"submit\" value=\"Upload Image\" />";
	$out.="<input type=\"submit\" name=\"aaa\" value=\"".$swipegallerymessage[58]."\" /></td>";
	$out.="</tr>\n</table>\n</fieldset>\n</form>\n<hr /><h3>".$swipegallerymessage[62]."</h3>\n";
	$out.="<form method=\"post\" action=\"\">\n<fieldset style=\"border: 0;\">\n";
	$out.="<table>\n<tr><td>$swipegallerymessage[117]:</td>\n<td>";
	$out.="<input name=\"galeryname\" type=\"text\" value=\"\" />\n</td></tr>\n";
	$out.="<tr><td><input type=\"hidden\" name=\"submit\" value=\"Create Swipe Gallery\" /></td>\n<td>";
	$out.="<input type=\"submit\" name=\"aa\" value=\"$swipegallerymessage[62]\" /></td>";
	$out.="</tr></table>\n</fieldset>\n</form>\n<hr />\n";
	$out.="<h3>".$swipegallerymessage[148]." ".$swipegallerymessage[176]."</h3>\n";

	$files=filelist('/./',$folder,1);
	$none=true;
	foreach($files as $file) {
		if($none) {
			$none=false;
			$out.="<table>";
		}
		if($file != ".." && $file != "." && $file != "thumbs") {
			$out.="<tr>";
			$out.="<td><a href=\"".$_SERVER["SCRIPT_NAME"]."?do=swipegallery&amp;action=deletegal&amp;name=$file\">";
			$out.="<img src=\"addons/swipegallery/editdelete.png\" alt=\"delete\" title=\"Delete Swipe Gallery $file\" align=\"left\" border=\"0\" /></a></td>";
			$out.="<td>".$file."</td></tr>\n";
		}
	}
	if(!$none) $out.="</table>\n";

	$out.="<hr /><h3>".$swipegallerymessage[148]." ".$swipegallerymessage[38]."</h3>\n";
	$out.="<table>\n";
	$folder="./swipegalleries";
	$files=filelist('/./',$folder,1);
	$gal=0;
	foreach($files as $file) {
	if($file != "thumbs") {
		if($gal==0) {
			$out.="\n<form method=\"post\" name=\"galery\" action=\"\">\n";
			$out.="<select onchange=\"document.galery.submit();\" name=\"selectgal\">\n";
			$first=$file;
		}
		$gal++;
		$out.="<option value=\"".$file."\"";
		if($_POST['selectgal']==$file)
			$out.=" selected";
		$out.=">".$file."&nbsp;</option>\n";
	}}
	if($gal>0) {
		$out.="</select></form>\n<br /><br />\n";
		if($_POST['selectgal']!="")
			$file=$_POST['selectgal'];
		else {
			$file=$first;
		}
		$folder1="./swipegalleries/".$file;
		$file1=filelist("/./",$folder1);
		foreach($file1 as $fil) {
			$out.="<tr><td><a href=\"".$_SERVER["SCRIPT_NAME"]."?do=swipegallery&amp;action=delete&amp;name=$folder1/$fil\">";
			$out.="<img src=\"addons/swipegallery/editdelete.png\" alt=\"delete\" title=\"Delete $fil\" align=\"left\" border=\"0\" /></a></td>";
			$thumb=makeThumb($folder1."/".$fil, "swipegalleries/thumbs/", $thumbnailwidth);
			if($row=fetch_array(dbquery("SELECT * FROM ".$prefix."sgimages WHERE file=\"".basename($thumb)."\"")))
				$filename=decode($row['name']);
			else
				$filename=$thumb;
			$out.="<td>$filename</td>";
			$out.="<td align=\"center\" >";
			$out.="<img src=\"swipegalleries/thumbs/$thumb\"  alt=\"$filename\"  title=\"$filename\" /></td></tr>\n";
		}
	}
	$out.="</table>\n";
	$out.="</div>\n";
	return $out;
}

function deleteimage($pathtofile, $basename="") {
	global $swipegallerymessage, $prefix;
	if(@unlink($pathtofile)) {
		if($basename=="") {
			$info = pathinfo($pathtofile);
			$basename = $info['basename'];
		}
		//remove database entry
		if($row=fetch_array(dbquery("SELECT * FROM ".$prefix."sgimages WHERE file=\"$basename\"")))
			dbquery("DELETE FROM ".$prefix."sgimages WHERE id=".$row['id']);
		//delete thumbnail too
		@unlink("swipegalleries/thumbs/".$basename);
		$out="<h2 class=\"LNE_message\">".$swipegallerymessage[149]."</h2>\n";
	} else
		$out="<h2 class=\"LNE_message\">".$swipegallerymessage[6]."</h2>\n";
	return $out;
}
?>
