<?php
/*---------------------------------------------------+
| LightNEasy Content Management System
| Copyright 2007 - 2011 Fernando Baptista
| http://www.lightneasy.org
+----------------------------------------------------+
| Addon Swipe Gallery
| Main Module
| Version 1.0
| Copyright 2014 TIOUK
|
| Contains the work of Fernando Baptista, Stu Nichols (http://www.stunicholls.com) and Others.
|
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------*/
function swipegallery($gal="", $width=0, $height=0) {
	global $swipegallerymessage, $set, $prefix;
	if(file_exists("addons/swipegallery/lang/lang_".$set['language'].".php"))
		require_once "addons/swipegallery/lang/lang_".$set['language'].".php";
	else
		require_once "addons/swipegallery/lang/lang_en_US.php";
	require_once "addons/swipegallery/common.php";

	if(file_exists("./addons/swipegallery/settings.php"))
		require_once "./addons/swipegallery/settings.php";

	$out="";
	if($gal!="") {
		$count=1;
		$out.="<h2>".$gal."</h2><br />\n";
		$galeries[0]=$gal;

	$out.="<div class=\"swipecontainer\" style=\"width:100%; height:".$swipeHeight."px; margin:0 -5px; position:relative; border-left:5px solid #000; border-right:5px solid #000; background:#000;\">\n<div class=\"swipeme\" data-arrows=\"true\" data-buttons=\"true\">\n<div class=\"slides\" id=\"".$gal."\">";


	} else {
		if(isset($_POST['gal'])) $gal=sanitize($_POST['gal']);
		$folder="swipegalleries";
		$files=filelist('/./',$folder,1);
		$folder="swipegalleries";
		$count=0;
		foreach($files as $file) {
			if($file != ".." && $file != "." && is_dir($folder."/".$file)) {
				$galeries[$count]=$file;
				$count++;
			}
		}
	}
	if($count>1) {
		for($i=0;$i<$count;$i++) {
			$out.='<option value="'.$galeries[$i].'"';
			if($gal==$galeries[$i]) $out.=" selected";
			$out.=">".$galeries[$i]."&nbsp;</option>\n";
			if($gal=="") $gal=$galeries[$i];
		}
	} else {
		$gal=$galeries[0];
	}
	//$gal contains the galery folder
	$gal="swipegalleries/".$gal;
	$filez=filelist('/./',$gal);
	foreach($filez as $file) {
		if($file!="index.html") {
			if(intval($thumbnailwidth)==0)
				$thumbnailwidth=200;
			if($row=fetch_array(dbquery("SELECT * FROM ".$prefix."sgimages WHERE file=\"".basename($file)."\"")))
				$filename=decode($row['name']);
			else
				$filename=$file;

			$tname=makeThumb( $gal."/".$file, "swipegalleries/thumbs/", $thumbnailwidth );

			$out.="<img data-caption=\"$filename\" src=\"".$gal."/$file\" alt=\"$filename\"/>";
		}
	}
	$out.="</div></div></div>";

	return $out;
}
?>
